'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _nwBuilder = require('nw-builder');

var _nwBuilder2 = _interopRequireDefault(_nwBuilder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NwBuilderPlugin = function () {
  function NwBuilderPlugin(options) {
    _classCallCheck(this, NwBuilderPlugin);

    this.defaultOptions = {
      flavor: 'normal',
      cacheDir: _path2.default.resolve(__dirname, '..', 'cache')
    };

    this.options = Object.assign(this.defaultOptions, options);
  }

  _createClass(NwBuilderPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      compiler.plugin('after-emit', this.onAfterEmit.bind(this));
    }
  }, {
    key: 'onAfterEmit',
    value: function onAfterEmit(compilation, callback) {
      var options = Object.assign({
        files: compilation.outputOptions.path + '/**/**'
      }, this.options);

      var nw = new _nwBuilder2.default(options);
      nw.on('log', console.log);
      nw.build().then(function () {
        console.log('NW.js build successfully.');
        callback();
      }).catch(function (err) {
        console.error(err);
      });
    }
  }]);

  return NwBuilderPlugin;
}();

exports.default = NwBuilderPlugin;